#include <iostream.h>
#include <sys/time.h>
#include "bench.h"
#include "bench_impl.h"

int
main (int argc, char *argv[])
{
    CORBA::ORB_var orb = CORBA::ORB_init (argc, argv, "mico-local-orb");
    CORBA::BOA_var boa = orb->BOA_init (argc, argv, "mico-local-boa");

    new Bench_impl;

    assert (argc == 2);
    CORBA::Object_var obj = orb->bind ("IDL:Bench:1.0", argv[1]);
    if (CORBA::is_nil (obj)) {
	cerr << "cannot bind to " << argv[1] << endl;
	return 1;
    }
    Bench_var bench = Bench::_narrow (obj);

    struct timeval tv1, tv2;

    gettimeofday (&tv1, 0);
    for (int i = 0; i < 5000; ++i) {
	bench->bench1 ();
    }
    gettimeofday (&tv2, 0);

    tv2.tv_sec -= tv1.tv_sec;
    tv1.tv_sec = 0;
    long elapsed =
	(tv2.tv_sec * 1000 + tv2.tv_usec / 1000) -
	(tv1.tv_sec * 1000 + tv1.tv_usec / 1000);

    cout << (double)elapsed/5000 << " ms per call" << endl;
    return 0;
}
