#include <iostream.h>
#include "hello.h"
#include <mico/x11.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>

Widget top, form, label, quit;

class Hello_impl : virtual public Hello_skel {
public:
    void hello (const char *s)
    {
	XtVaSetValues (label,
		       XtNlabel, s,
		       NULL);
    }
};

void
quit_cb (Widget, XtPointer, XtPointer)
{
    exit (0);
}

int
main (int argc, char *argv[])
{
    /*
     * MICO initialization
     */
    CORBA::ORB_var orb = CORBA::ORB_init (argc, argv, "mico-local-orb");
    CORBA::BOA_var boa = orb->BOA_init (argc, argv, "mico-local-boa");

    /*
     * X11 initialization
     */
    static String fallback_res[] = {
	"*argument.label: ",
	"*quit.label: Quit",
	NULL
    };

    XtAppContext appctx;
    top = XtAppInitialize (&appctx, "Xhello",
			   0, 0,
			   &argc, argv,
			   fallback_res,
			   0, 0);

    /*
     * Use X11 dispatcher
     */
    orb->dispatcher (new X11Dispatcher (appctx));

    /*
     * MICO stuff
     */
    new Hello_impl;

    /*
     * X11 stuff
     */
    form = XtVaCreateManagedWidget ("form",
				   formWidgetClass,
				   top,
				   NULL);

    // label
    label = XtVaCreateManagedWidget ("argument",
				     labelWidgetClass,
				     form,
				     XtNwidth, 150,
				     XtNjustify, XtJustifyLeft,
				     NULL);

    // quit button
    quit = XtVaCreateManagedWidget ("quit",
				    commandWidgetClass,
				    form,
				    XtNfromVert, label,
				    NULL);
    XtAddCallback (quit, XtNcallback, quit_cb, 0);


    XtRealizeWidget (top);
    boa->impl_is_ready (CORBA::ImplementationDef::_nil());

    return 0;
}
