#ifndef CORBA_C_H
#define CORBA_C_H 1

#include <mico/config.h>
#include <mico/assert.h>
#include <mico/types.h>

#ifndef CPP_WRAPPER
typedef MICO_Short CORBA_short;
typedef MICO_Long CORBA_long;
typedef MICO_UShort CORBA_unsigned_short;
typedef MICO_ULong CORBA_unsigned_long;
typedef MICO_Float CORBA_float;
typedef MICO_Double CORBA_double;
typedef MICO_Char CORBA_char;
typedef MICO_Boolean CORBA_boolean;
typedef MICO_Octet CORBA_octet;
typedef char * CORBA_string;
typedef void * CORBA_TypeCode;
typedef void * CORBA_TypeCode_ptr;
typedef struct {
  CORBA_TypeCode _type;
  void *_value;
} CORBA_any;
typedef void * CORBA_Environment;

typedef void * CORBA_Object; /* Bleah */
typedef void * CORBA_ORB;
typedef void * CORBA_BOA;
typedef void * CORBA_Dispatcher;

#else
/* Used only internally by the wrapper stuff */
typedef CORBA::Short CORBA_short;
typedef CORBA::Long CORBA_long;
typedef CORBA::UShort CORBA_unsigned_short;
typedef CORBA::ULong CORBA_unsigned_long;
typedef CORBA::Float CORBA_float;
typedef CORBA::Double CORBA_double;
typedef CORBA::Char CORBA_char;
typedef CORBA::Boolean CORBA_boolean;
typedef CORBA::Octet CORBA_octet;
typedef char *CORBA_string;
typedef char *CORBA_String_var;
typedef CORBA::TypeCode_ptr CORBA_TypeCode;
typedef CORBA::TypeCode_ptr CORBA_TypeCode_ptr;
typedef CORBA::Any *CORBA_any;
typedef CORBA::Environment CORBA_Environment;
typedef CORBA::Object_ptr CORBA_Object;
typedef CORBA::ORB_ptr CORBA_ORB;
typedef CORBA::BOA_ptr CORBA_BOA;
typedef CORBA::Dispatcher *CORBA_Dispatcher;
#define TRUE 1
#define FALSE 0

#endif

extern CORBA_ORB CORBA_ORB_init(int *argcp,
				char ***argvp,
				const char *id);
extern CORBA_BOA CORBA_BOA_init(CORBA_ORB orb,
				int *argcp,
				char ***argvp,
				const char *id);
/* Pass in addr = NULL if you like */
extern CORBA_Object CORBA_ORB_bind(CORBA_ORB orb,
				   const char *repoid,
				   const char *addr);
extern CORBA_Object CORBA_ORB_string_to_object(CORBA_ORB orb,
					       const char *iorstring);
extern char *CORBA_ORB_object_to_string(CORBA_ORB orb,
					CORBA_Object obj);
extern void CORBA_ORB_dispatcher(CORBA_ORB orb, CORBA_Dispatcher disp);
extern CORBA_Dispatcher gtk_dispatcher_new(void);
extern CORBA_boolean CORBA_Object_is_nil(CORBA_Object obj);
extern void CORBA_BOA_impl_is_ready(CORBA_BOA boa, CORBA_Object obj);

#endif
