/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997, 1998 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__COSEVENTCOMM_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __COSEVENTCOMM_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

// Generate forward declarations for this scope

// Module CosEventComm
#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL CosEventComm {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosEventComm)

// Generate forward declarations for this scope
class PushConsumer;
typedef PushConsumer *PushConsumer_ptr;
typedef PushConsumer_ptr PushConsumerRef;
typedef ObjVar<PushConsumer> PushConsumer_var;

class PushSupplier;
typedef PushSupplier *PushSupplier_ptr;
typedef PushSupplier_ptr PushSupplierRef;
typedef ObjVar<PushSupplier> PushSupplier_var;

class PullSupplier;
typedef PullSupplier *PullSupplier_ptr;
typedef PullSupplier_ptr PullSupplierRef;
typedef ObjVar<PullSupplier> PullSupplier_var;

class PullConsumer;
typedef PullConsumer *PullConsumer_ptr;
typedef PullConsumer_ptr PullConsumerRef;
typedef ObjVar<PullConsumer> PullConsumer_var;


struct Disconnected : public CORBA::UserException {
  Disconnected();
  ~Disconnected();
  Disconnected( const Disconnected& s );
  Disconnected& operator=( const Disconnected& s );
  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  Disconnected *_clone() const;
  static Disconnected *_narrow( CORBA::Exception *ex );
};

typedef ExceptVar<Disconnected> Disconnected_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_Disconnected;


// Common definitions for interface PushConsumer
class PushConsumer : virtual public CORBA::Object
{
  public:
    virtual ~PushConsumer();
    static PushConsumer_ptr _duplicate( PushConsumer_ptr obj );
    static PushConsumer_ptr _narrow( CORBA::Object_ptr obj );
    static PushConsumer_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void push( const CORBA::Any& data ) = 0;
    virtual void disconnect_push_consumer() = 0;
  protected:
    PushConsumer() {};
  private:
    PushConsumer( const PushConsumer& );
    void operator=( const PushConsumer& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_PushConsumer;

// Stub for interface PushConsumer
class PushConsumer_stub : virtual public PushConsumer
{
  public:
    virtual ~PushConsumer_stub();
    void push( const CORBA::Any& data );
    void disconnect_push_consumer();
  private:
    void operator=( const PushConsumer_stub& );
};

class PushConsumer_skel :
  virtual public MethodDispatcher,
  virtual public PushConsumer
{
  public:
    PushConsumer_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~PushConsumer_skel();
    PushConsumer_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    PushConsumer_ptr _this();

};


// Common definitions for interface PushSupplier
class PushSupplier : virtual public CORBA::Object
{
  public:
    virtual ~PushSupplier();
    static PushSupplier_ptr _duplicate( PushSupplier_ptr obj );
    static PushSupplier_ptr _narrow( CORBA::Object_ptr obj );
    static PushSupplier_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void disconnect_push_supplier() = 0;
  protected:
    PushSupplier() {};
  private:
    PushSupplier( const PushSupplier& );
    void operator=( const PushSupplier& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_PushSupplier;

// Stub for interface PushSupplier
class PushSupplier_stub : virtual public PushSupplier
{
  public:
    virtual ~PushSupplier_stub();
    void disconnect_push_supplier();
  private:
    void operator=( const PushSupplier_stub& );
};

class PushSupplier_skel :
  virtual public MethodDispatcher,
  virtual public PushSupplier
{
  public:
    PushSupplier_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~PushSupplier_skel();
    PushSupplier_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    PushSupplier_ptr _this();

};


// Common definitions for interface PullSupplier
class PullSupplier : virtual public CORBA::Object
{
  public:
    virtual ~PullSupplier();
    static PullSupplier_ptr _duplicate( PullSupplier_ptr obj );
    static PullSupplier_ptr _narrow( CORBA::Object_ptr obj );
    static PullSupplier_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual CORBA::Any* pull() = 0;
    virtual CORBA::Any* try_pull( CORBA::Boolean& has_event ) = 0;
    virtual void disconnect_pull_supplier() = 0;
  protected:
    PullSupplier() {};
  private:
    PullSupplier( const PullSupplier& );
    void operator=( const PullSupplier& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_PullSupplier;

// Stub for interface PullSupplier
class PullSupplier_stub : virtual public PullSupplier
{
  public:
    virtual ~PullSupplier_stub();
    CORBA::Any* pull();
    CORBA::Any* try_pull( CORBA::Boolean& has_event );
    void disconnect_pull_supplier();
  private:
    void operator=( const PullSupplier_stub& );
};

class PullSupplier_skel :
  virtual public MethodDispatcher,
  virtual public PullSupplier
{
  public:
    PullSupplier_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~PullSupplier_skel();
    PullSupplier_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    PullSupplier_ptr _this();

};


// Common definitions for interface PullConsumer
class PullConsumer : virtual public CORBA::Object
{
  public:
    virtual ~PullConsumer();
    static PullConsumer_ptr _duplicate( PullConsumer_ptr obj );
    static PullConsumer_ptr _narrow( CORBA::Object_ptr obj );
    static PullConsumer_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void disconnect_pull_consumer() = 0;
  protected:
    PullConsumer() {};
  private:
    PullConsumer( const PullConsumer& );
    void operator=( const PullConsumer& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_PullConsumer;

// Stub for interface PullConsumer
class PullConsumer_stub : virtual public PullConsumer
{
  public:
    virtual ~PullConsumer_stub();
    void disconnect_pull_consumer();
  private:
    void operator=( const PullConsumer_stub& );
};

class PullConsumer_skel :
  virtual public MethodDispatcher,
  virtual public PullConsumer
{
  public:
    PullConsumer_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~PullConsumer_skel();
    PullConsumer_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    PullConsumer_ptr _this();

};

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosEventComm)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosEventComm::Disconnected &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosEventComm::Disconnected &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosEventComm::PushConsumer_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosEventComm::PushConsumer_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosEventComm::PushSupplier_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosEventComm::PushSupplier_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosEventComm::PullSupplier_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosEventComm::PullSupplier_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosEventComm::PullConsumer_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosEventComm::PullConsumer_ptr &obj );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#ifndef MICO_NO_TOPLEVEL_MODULES
#include <mico/template_impl.h>
#endif

#endif
