/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997, 1998 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__NAMING_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __NAMING_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

// Generate forward declarations for this scope

// Module CosNaming
#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL CosNaming {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosNaming)

// Generate forward declarations for this scope
class NamingContext;
typedef NamingContext *NamingContext_ptr;
typedef NamingContext_ptr NamingContextRef;
typedef ObjVar<NamingContext> NamingContext_var;

class BindingIterator;
typedef BindingIterator *BindingIterator_ptr;
typedef BindingIterator_ptr BindingIteratorRef;
typedef ObjVar<BindingIterator> BindingIterator_var;


typedef char* Istring;
typedef CORBA::String_var Istring_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_Istring;

struct NameComponent {
  NameComponent();
  ~NameComponent();
  NameComponent( const NameComponent& s );
  NameComponent& operator=( const NameComponent& s );
  CosNaming::Istring_var id;
  CosNaming::Istring_var kind;
};

typedef TVar<NameComponent> NameComponent_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_NameComponent;

typedef SequenceTmpl<CosNaming::NameComponent> Name;
typedef TSeqVar<SequenceTmpl<CosNaming::NameComponent> > Name_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_Name;

enum BindingType {
  nobject = 0,
  ncontext
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_BindingType;

struct Binding {
  Binding();
  ~Binding();
  Binding( const Binding& s );
  Binding& operator=( const Binding& s );
  CosNaming::Name binding_name;
  CosNaming::BindingType binding_type;
};

typedef TVar<Binding> Binding_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_Binding;

typedef SequenceTmpl<CosNaming::Binding> BindingList;
typedef TSeqVar<SequenceTmpl<CosNaming::Binding> > BindingList_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_BindingList;


// Common definitions for interface NamingContext
class NamingContext : virtual public CORBA::Object
{
  public:
    virtual ~NamingContext();
    static NamingContext_ptr _duplicate( NamingContext_ptr obj );
    static NamingContext_ptr _narrow( CORBA::Object_ptr obj );
    static NamingContext_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    enum NotFoundReason {
      missing_node = 0,
      not_context,
      not_object
    };

    static CORBA::TypeCode_ptr _tc_NotFoundReason;

    struct NotFound : public CORBA::UserException {
      NotFound();
      ~NotFound();
      NotFound( const NotFound& s );
      NotFound& operator=( const NotFound& s );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      NotFound *_clone() const;
      static NotFound *_narrow( CORBA::Exception *ex );
      CosNaming::NamingContext::NotFoundReason why;
      CosNaming::Name rest_of_name;
    };

    typedef ExceptVar<NotFound> NotFound_var;

    static CORBA::TypeCode_ptr _tc_NotFound;

    struct CannotProceed : public CORBA::UserException {
      CannotProceed();
      ~CannotProceed();
      CannotProceed( const CannotProceed& s );
      CannotProceed& operator=( const CannotProceed& s );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CannotProceed *_clone() const;
      static CannotProceed *_narrow( CORBA::Exception *ex );
      CosNaming::NamingContext_var cxt;
      CosNaming::Name rest_of_name;
    };

    typedef ExceptVar<CannotProceed> CannotProceed_var;

    static CORBA::TypeCode_ptr _tc_CannotProceed;

    struct InvalidName : public CORBA::UserException {
      InvalidName();
      ~InvalidName();
      InvalidName( const InvalidName& s );
      InvalidName& operator=( const InvalidName& s );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      InvalidName *_clone() const;
      static InvalidName *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<InvalidName> InvalidName_var;

    static CORBA::TypeCode_ptr _tc_InvalidName;

    struct AlreadyBound : public CORBA::UserException {
      AlreadyBound();
      ~AlreadyBound();
      AlreadyBound( const AlreadyBound& s );
      AlreadyBound& operator=( const AlreadyBound& s );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      AlreadyBound *_clone() const;
      static AlreadyBound *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<AlreadyBound> AlreadyBound_var;

    static CORBA::TypeCode_ptr _tc_AlreadyBound;

    struct NotEmpty : public CORBA::UserException {
      NotEmpty();
      ~NotEmpty();
      NotEmpty( const NotEmpty& s );
      NotEmpty& operator=( const NotEmpty& s );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      NotEmpty *_clone() const;
      static NotEmpty *_narrow( CORBA::Exception *ex );
    };

    typedef ExceptVar<NotEmpty> NotEmpty_var;

    static CORBA::TypeCode_ptr _tc_NotEmpty;

    virtual void bind( const CosNaming::Name& n, CORBA::Object_ptr obj ) = 0;
    virtual void rebind( const CosNaming::Name& n, CORBA::Object_ptr obj ) = 0;
    virtual void bind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc ) = 0;
    virtual void rebind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc ) = 0;
    virtual CORBA::Object_ptr resolve( const CosNaming::Name& n ) = 0;
    virtual void unbind( const CosNaming::Name& n ) = 0;
    virtual CosNaming::NamingContext_ptr new_context() = 0;
    virtual CosNaming::NamingContext_ptr bind_new_context( const CosNaming::Name& n ) = 0;
    virtual void destroy() = 0;
    virtual void list( CORBA::ULong how_many, CosNaming::BindingList*& bl, CosNaming::BindingIterator_ptr& bi ) = 0;
  protected:
    NamingContext() {};
  private:
    NamingContext( const NamingContext& );
    void operator=( const NamingContext& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_NamingContext;

// Stub for interface NamingContext
class NamingContext_stub : virtual public NamingContext
{
  public:
    virtual ~NamingContext_stub();
    void bind( const CosNaming::Name& n, CORBA::Object_ptr obj );
    void rebind( const CosNaming::Name& n, CORBA::Object_ptr obj );
    void bind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc );
    void rebind_context( const CosNaming::Name& n, CosNaming::NamingContext_ptr nc );
    CORBA::Object_ptr resolve( const CosNaming::Name& n );
    void unbind( const CosNaming::Name& n );
    CosNaming::NamingContext_ptr new_context();
    CosNaming::NamingContext_ptr bind_new_context( const CosNaming::Name& n );
    void destroy();
    void list( CORBA::ULong how_many, CosNaming::BindingList*& bl, CosNaming::BindingIterator_ptr& bi );
  private:
    void operator=( const NamingContext_stub& );
};

class NamingContext_skel :
  virtual public MethodDispatcher,
  virtual public NamingContext
{
  public:
    NamingContext_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~NamingContext_skel();
    NamingContext_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    NamingContext_ptr _this();

};


// Common definitions for interface BindingIterator
class BindingIterator : virtual public CORBA::Object
{
  public:
    virtual ~BindingIterator();
    static BindingIterator_ptr _duplicate( BindingIterator_ptr obj );
    static BindingIterator_ptr _narrow( CORBA::Object_ptr obj );
    static BindingIterator_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual CORBA::Boolean next_one( CosNaming::Binding*& b ) = 0;
    virtual CORBA::Boolean next_n( CORBA::ULong how_many, CosNaming::BindingList*& bl ) = 0;
    virtual void destroy() = 0;
  protected:
    BindingIterator() {};
  private:
    BindingIterator( const BindingIterator& );
    void operator=( const BindingIterator& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_BindingIterator;

// Stub for interface BindingIterator
class BindingIterator_stub : virtual public BindingIterator
{
  public:
    virtual ~BindingIterator_stub();
    CORBA::Boolean next_one( CosNaming::Binding*& b );
    CORBA::Boolean next_n( CORBA::ULong how_many, CosNaming::BindingList*& bl );
    void destroy();
  private:
    void operator=( const BindingIterator_stub& );
};

class BindingIterator_skel :
  virtual public MethodDispatcher,
  virtual public BindingIterator
{
  public:
    BindingIterator_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~BindingIterator_skel();
    BindingIterator_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    BindingIterator_ptr _this();

};

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosNaming)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &_a, const SequenceTmpl<CosNaming::NameComponent> &_s );

CORBA::Boolean operator>>=( const CORBA::Any &_a, SequenceTmpl<CosNaming::NameComponent> &_s );

CORBA::Boolean operator<<=( CORBA::Any &_a, const SequenceTmpl<CosNaming::Binding> &_s );

CORBA::Boolean operator>>=( const CORBA::Any &_a, SequenceTmpl<CosNaming::Binding> &_s );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &_a, const ::CosNaming::NameComponent &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::CosNaming::NameComponent &_s );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::BindingType &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::BindingType &e );

CORBA::Boolean operator<<=( CORBA::Any &_a, const ::CosNaming::Binding &_s );
CORBA::Boolean operator>>=( const CORBA::Any &_a, ::CosNaming::Binding &_s );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::NotFoundReason &e );

CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::NotFoundReason &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::NotFound &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::NotFound &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::CannotProceed &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::CannotProceed &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::InvalidName &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::InvalidName &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::AlreadyBound &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::AlreadyBound &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::CosNaming::NamingContext::NotEmpty &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::CosNaming::NamingContext::NotEmpty &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosNaming::NamingContext_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosNaming::NamingContext_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const CosNaming::BindingIterator_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, CosNaming::BindingIterator_ptr &obj );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#ifndef MICO_NO_TOPLEVEL_MODULES
#include <mico/template_impl.h>
#endif

#endif
