// -*- c++ -*-
/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997 Kay Roemer & Arno Puder
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#ifndef __mico_orb_impl_h__
#define __mico_orb_impl_h__

class LocalRequest : public CORBA::ORBRequest {
    CORBA::Request_ptr req;
    CORBA::Boolean have_except;
    CORBA::Boolean have_result;
public:
    LocalRequest ();
    LocalRequest (CORBA::Request_ptr);
    virtual ~LocalRequest ();

    virtual const char *op_name();

    virtual void get_in_args (CORBA::NVList_ptr iparams,
			      CORBA::Context_ptr &ctx);
    virtual void get_in_args (CORBA::DataEncoder *);

    virtual void get_out_args (CORBA::Any *res,
			       CORBA::NVList_ptr oparams,
			       CORBA::Exception *&ex);
    virtual void get_out_args (CORBA::DataEncoder *,
			       CORBA::Boolean &is_except);

    virtual void set_out_args (CORBA::Any *res, CORBA::NVList_ptr oparams);
    virtual void set_out_args (CORBA::Exception *ex);

    virtual void copy_out_args (CORBA::ORBRequest *);
    virtual void copy_in_args (CORBA::ORBRequest *);

    virtual const char *type ();

    CORBA::Request_ptr request ();

    static LocalRequest* _nil ();
    static LocalRequest* _duplicate (LocalRequest *);
};

#endif // __mico_orb_impl_h__
