// -*- c++ -*-
/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997 Kay Roemer & Arno Puder
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#ifndef __mico_process_h__
#define __mico_process_h__

class Process;

struct ProcessCallback {
    enum Event { Exited };
    virtual void callback (Process *, Event) = 0;
    virtual ~ProcessCallback ();
};

class Process {
public:
    virtual ~Process ();
    virtual Boolean exited () = 0;
    virtual Boolean exit_status () = 0;
    virtual void terminate () = 0;
    virtual void detach () = 0;
    virtual operator Boolean () = 0;
};


#endif // __mico_process_h__
