/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997, 1998 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__STREAM_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __STREAM_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

// Generate forward declarations for this scope

// Module MICOStream
#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL MICOStream {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_MICOStream)

// Generate forward declarations for this scope
class Transport;
typedef Transport *Transport_ptr;
typedef Transport_ptr TransportRef;
typedef ObjVar<Transport> Transport_var;

class ActiveCEP;
typedef ActiveCEP *ActiveCEP_ptr;
typedef ActiveCEP_ptr ActiveCEPRef;
typedef ObjVar<ActiveCEP> ActiveCEP_var;

class PassiveCEP;
typedef PassiveCEP *PassiveCEP_ptr;
typedef PassiveCEP_ptr PassiveCEPRef;
typedef ObjVar<PassiveCEP> PassiveCEP_var;


typedef SequenceTmpl<CORBA::OctetWrapper> StreamData;
typedef TSeqVar<SequenceTmpl<CORBA::OctetWrapper> > StreamData_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_StreamData;

struct NotBound : public CORBA::UserException {
  NotBound();
  ~NotBound();
  NotBound( const NotBound& s );
  NotBound& operator=( const NotBound& s );
  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  NotBound *_clone() const;
  static NotBound *_narrow( CORBA::Exception *ex );
};

typedef ExceptVar<NotBound> NotBound_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_NotBound;

struct NotConnected : public CORBA::UserException {
  NotConnected();
  ~NotConnected();
  NotConnected( const NotConnected& s );
  NotConnected& operator=( const NotConnected& s );
  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  NotConnected *_clone() const;
  static NotConnected *_narrow( CORBA::Exception *ex );
};

typedef ExceptVar<NotConnected> NotConnected_var;

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_NotConnected;


// Common definitions for interface Transport
class Transport : virtual public CORBA::Object
{
  public:
    virtual ~Transport();
    static Transport_ptr _duplicate( Transport_ptr obj );
    static Transport_ptr _narrow( CORBA::Object_ptr obj );
    static Transport_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual MICOStream::StreamData* poll() = 0;
    virtual MICOStream::StreamData* read() = 0;
    virtual void receive( const MICOStream::StreamData& chunk ) = 0;
    virtual void write( const MICOStream::StreamData& chunk ) = 0;
    virtual void write_async( const MICOStream::StreamData& chunk ) = 0;
  protected:
    Transport() {};
  private:
    Transport( const Transport& );
    void operator=( const Transport& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_Transport;

// Stub for interface Transport
class Transport_stub : virtual public Transport
{
  public:
    virtual ~Transport_stub();
    MICOStream::StreamData* poll();
    MICOStream::StreamData* read();
    void receive( const MICOStream::StreamData& chunk );
    void write( const MICOStream::StreamData& chunk );
    void write_async( const MICOStream::StreamData& chunk );
  private:
    void operator=( const Transport_stub& );
};

class Transport_skel :
  virtual public MethodDispatcher,
  virtual public Transport
{
  public:
    Transport_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~Transport_skel();
    Transport_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    Transport_ptr _this();

};


// Common definitions for interface ActiveCEP
class ActiveCEP : 
  virtual public ::MICOStream::Transport
{
  public:
    virtual ~ActiveCEP();
    static ActiveCEP_ptr _duplicate( ActiveCEP_ptr obj );
    static ActiveCEP_ptr _narrow( CORBA::Object_ptr obj );
    static ActiveCEP_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void connect( const char* bind_addr ) = 0;
    virtual void disconnect() = 0;
  protected:
    ActiveCEP() {};
  private:
    ActiveCEP( const ActiveCEP& );
    void operator=( const ActiveCEP& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_ActiveCEP;

// Stub for interface ActiveCEP
class ActiveCEP_stub : virtual public ActiveCEP,
  virtual public ::MICOStream::Transport_stub
{
  public:
    virtual ~ActiveCEP_stub();
    void connect( const char* bind_addr );
    void disconnect();
  private:
    void operator=( const ActiveCEP_stub& );
};

class ActiveCEP_skel :
  virtual public MethodDispatcher,
  virtual public ActiveCEP
{
  public:
    ActiveCEP_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~ActiveCEP_skel();
    ActiveCEP_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    ActiveCEP_ptr _this();

};


// Common definitions for interface PassiveCEP
class PassiveCEP : 
  virtual public ::MICOStream::Transport
{
  public:
    virtual ~PassiveCEP();
    static PassiveCEP_ptr _duplicate( PassiveCEP_ptr obj );
    static PassiveCEP_ptr _narrow( CORBA::Object_ptr obj );
    static PassiveCEP_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual char* bind_addr() = 0;
    virtual void bind( const char* bind_addr ) = 0;
    virtual void disconnect() = 0;
  protected:
    PassiveCEP() {};
  private:
    PassiveCEP( const PassiveCEP& );
    void operator=( const PassiveCEP& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_PassiveCEP;

// Stub for interface PassiveCEP
class PassiveCEP_stub : virtual public PassiveCEP,
  virtual public ::MICOStream::Transport_stub
{
  public:
    virtual ~PassiveCEP_stub();
    char* bind_addr();
    void bind( const char* bind_addr );
    void disconnect();
  private:
    void operator=( const PassiveCEP_stub& );
};

class PassiveCEP_skel :
  virtual public MethodDispatcher,
  virtual public PassiveCEP
{
  public:
    PassiveCEP_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~PassiveCEP_skel();
    PassiveCEP_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    PassiveCEP_ptr _this();

};

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_MICOStream)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &_a, const SequenceTmpl<CORBA::OctetWrapper> &_s );

CORBA::Boolean operator>>=( const CORBA::Any &_a, SequenceTmpl<CORBA::OctetWrapper> &_s );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &a, const ::MICOStream::NotBound &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::MICOStream::NotBound &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const ::MICOStream::NotConnected &e );
CORBA::Boolean operator>>=( const CORBA::Any &a, ::MICOStream::NotConnected &e );

CORBA::Boolean operator<<=( CORBA::Any &a, const MICOStream::Transport_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, MICOStream::Transport_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const MICOStream::ActiveCEP_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, MICOStream::ActiveCEP_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const MICOStream::PassiveCEP_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, MICOStream::PassiveCEP_ptr &obj );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#ifndef MICO_NO_TOPLEVEL_MODULES
#include <mico/template_impl.h>
#endif

#endif
