// -*- c++ -*-
/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997 Kay Roemer & Arno Puder
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#ifndef __mico_string_h__
#define __mico_string_h__

// strings
class String_var {
    char *str;
    char *str_backup;
    void check ();
public:
    String_var ();
    String_var (char *);
    String_var (const char *);
    String_var (const String_var &);
    ~String_var ();

    String_var &operator= (char *);
    String_var &operator= (const char *);
    String_var &operator= (const String_var &);
    // begin-mico-extension
    Boolean operator== (const String_var &s) const;
    // end-mico-extension
    /*
     * XXX non conformant to [16-11], but needed for out/inout parameter
     * passing, see [16-45].
     */
    operator char*& ();
    operator const char * () const;
    char &operator[] (ULong idx);
    char operator[] (ULong idx) const;

    char * _retn ();
};

MICO_EXPORT_DECL char *string_alloc (ULong len);
MICO_EXPORT_DECL char *string_dup (const char *);
MICO_EXPORT_DECL char *string_ndup (const char *, ULong len);
MICO_EXPORT_DECL void string_free (char *);

#endif // __mico_string_h__
