// -*- c++ -*-
/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997 Kay Roemer & Arno Puder
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 */

#ifndef __mico_throw_h__
#define __mico_throw_h__

static void
mico_throw (const CORBA::Exception &_ex)
{
    CORBA::Exception *ex = (CORBA::Exception *)&_ex;
    ex->_prepare_throw ();

#ifdef HAVE_EXCEPTIONS
    if (CORBA::SystemException *s = CORBA::SystemException::_narrow (ex))
	throw CORBA::SystemException_var (s->_clone());
    else if (CORBA::UserException *u = CORBA::UserException::_narrow (ex))
	u->_throwit();
#endif
    CORBA::Exception::_throw_failed (ex);
}

static inline ostream &
operator<< (ostream &os, CORBA::Exception *ex)
{
    ex->_print (os);
    return os;
}

#endif // __mico_throw_h__
